' InfoLaufwerk.Inc  Prozedur: hole Angaben zu einem Laufwerk

' Eine Anwendung der Prozedur ist in InfoLaufwerk.prf enthalten

'----------------------------------------------------------------------------------
' Version 1.2  6.05.2010.      Die Prozedur kann frei benutzt werden, fr
'                              Schden kann keine Haftung bernommen werden.
' Autor: Gerhard Putschalka    
'                       email: gerhard-putschalka@gmx.at
'                    homepage: http://www.gerhard-putschalka.xprofan.com/index.htm
'----------------------------------------------------------------------------------

' diese Definition und das Declare gehren zur Prozedur GetDriveInfo
Def GetDriveInfo(8)   ! "Kernel32.dll", "GetVolumeInformationA"
Declare Volum_Buf#


' Die Prozedur liest Daten eines Laufwerks.
Proc InfoLaufwerk
   Parameters Lw$ ' z.B. C: oder D: oder ...

' In der Retourvariablen sind die einzelnen Werte durch Tabulatorenbytes getrennt.
' Daten: Laufwerk, Laufwerktype, Laufwerknummer (in Hexdarstellung), Volum-Id,
'  Dateisystem, Dateisystem-Flags (in Hexdarstellung)

' Bedeutung der Dateisystem-Flags:
'  $1    = If this flag is set, the file system supports case-sensitive filenames.
'  $2    = If this flag is set, the file system preserves the case of filenames when
'          it places a name on disk.
'  $4    = If this flag is set, the file system supports Unicode in filenames as they
'          appear on disk.
'  $8    = If this flag is set, the file system preserves and enforces ACLs. For example,
'          NTFS preserves and enforces ACLs, and FAT does not.
'  $10   = The file system supports file-based compression.
'  $8000 = The specified volume is a compressed volume; for example, a DoubleSpace volume.

   Declare Hx$,Ret&,DType$,InfoZeile$
   Dim Volum_Buf#,300
   String Volum_Buf#,0=Lw$
   DType$ = @Str$(GetDriveType(Volum_Buf#,0))
   Clear Volum_Buf#
   String Volum_Buf#,0 = Lw$
   Ret&=GetDriveInfo(Volum_Buf#,(Volum_Buf# + 11),16,(Volum_Buf# + 27),(Volum_Buf# + 35),\
                     (Volum_Buf# + 39),(Volum_Buf# + 43),255)
   If Ret&
      ' sieht kompliziert aus, setzt aber (nicht ausgegebene) fhrende Nullen
      ' (wird @Hex mit Long verwendet kommen falsche Werte ab $8000 aufwrts)
      Hx$ = @Right$("00"+@Hex$(Byte(Volum_Buf#,30)),2)
      Hx$ = Hx$+@Right$("00"+@Hex$(Byte(Volum_Buf#,29)),2)+"-"
      Hx$ = Hx$+@Right$("00"+@Hex$(Byte(Volum_Buf#,28)),2)
      Hx$ = Hx$+@Right$("00"+@Hex$(Byte(Volum_Buf#,27)),2)

      InfoZeile$ = Lw$+"\t"+DType$+"\t"+Hx$+"\t"+@String$(Volum_Buf#,11)+"\t"+\
                   @String$(Volum_Buf#,43)+"\t"+@Hex$(@Long(Volum_Buf#,39))
   Else  ' es wurden keine Daten gefunden
      InfoZeile$ = Lw$+"\t"+DType$+"\t"+"es wurden keine Angaben gefunden / Laufw. nicht bereit"
   EndIf
   Dispose Volum_Buf#
   Return InfoZeile$
EndProc
